//	author:	Barnabas Aszodi (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "CAURenderFinalPass.h"


CAURenderFinalPass::CAURenderFinalPass(
			Root* mRoot):ManagedOgreRenderTexturePass(mRoot, ManagedOgreRenderTexturePass::noRenderTargetName,1,1)
{
	effectWrapper->createMaterial("CAURenderFinalPass");
}

void CAURenderFinalPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetVertexProgramParameters();
	effectWrapper->SetMatrix("g_mWorldViewProj",g_mWorldViewProj);
}


void CAURenderFinalPass::onRenderEnd(NameValuePairList* namedParams)
{
	effectWrapper->EndPass();
}

Matrix4 CAURenderFinalPass::getWorldViewProj()
{
	return g_mWorldViewProj;
}

void CAURenderFinalPass::setWorldViewProj( Matrix4 matrix4 )
{
	g_mWorldViewProj = matrix4;
}